berou/application_system/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import url

from application_system import views

urlpatterns = [
    url(r'^$', views.ListAppView.as_view(), name='list_app'),
    url(r'^manage_my_apps/$',
        views.ListAvailableAppView.as_view(),
        name='manage_my_apps'),
    url(r'^install_app/$', views.InstallAppView.as_view(), name='install_app'),
    url(r'^uninstall_app/(?P<package>[\w-]+)/$',
        views.UninstallAppView.as_view(),
        name='uninstall_app'),
    url(r'activate_app/(?P<package>[\w-]+)/$',
        views.ActivateAppView.as_view(),
        name='activate_app'),
    url(r'disable_app/(?P<package>[\w-]+)/$',
        views.DisableAppView.as_view(),
        name='disable_app'),
]

berou/berou/urls.py
# -*- coding: utf-8 -*-

import importlib
import logging

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin

from accounts import urls as accounts_urls
from berou import berou_urls
from application_system import urls as application_system_urls
from application_system import models

logger = logging.getLogger('berou')


def get_plugin_packages():
    return [app.package for app in models.App.objects.all()]


urlpatterns = [
    # Examples:
    # url(r'^$', 'berou.views.home', name='home'),
    # url(r'^blog/', include('blog.urls')),

    url(r'^admin/', include(admin.site.urls)),
    url(r'^accounts/', include(accounts_urls, namespace='accounts')),
    url(r'^application_system/', include(application_system_urls,
                                         namespace='application_system')),
    url(r'^', include(berou_urls, namespace='berou')),

]

for plugin in get_plugin_packages():
    plugin_package = importlib.import_module(plugin)

    try:
        urls = importlib.import_module('{app}.urls'.format(app=plugin))
    except ImportError as error:
        if error != ('No module named urls',):
            raise
        else:
            logger.info('App {pp} does not have a urls file', app=plugin)
    else:
        plugin_urls = url(
            r'^{plugin}/'.format(plugin=plugin),
            include(urls, namespace=plugin)
        )
        urlpatterns.append(plugin_urls)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

berou/blog/urls.py
from django.conf.urls import url
from blog import views

urlpatterns = [
    url(r'^create$', views.CreatePostView.as_view(), name='create'),
    url(r'^$', views.ListPostView.as_view(), name='list'),
    url(r'^test$', views.Test.as_view(), name='list'),

    # url(r'^$', views.ListPostView.as_view(), name='list'),
 ]

berou/application_system/models.py
#!/usr/bin/env python
# -*- coding: utf-8 -*-

import logging

from django.conf import settings
from django.core.urlresolvers import reverse
from django.db import models
from django.utils.translation import ugettext_lazy as _

logger = logging.getLogger('berou')


class App(models.Model):
    class Meta:
        verbose_name = _('Application')
        verbose_name_plural = _('Applications')

    name = models.CharField(max_length=200, verbose_name=_('Name'))
    description = models.CharField(
        max_length=200,
        default='',
        verbose_name=_('Description')
    )
    package = models.CharField(
        max_length=200,
        unique=True,
        verbose_name=_('Package name'),
        default=None
    )
    logo = models.CharField(
        max_length=200,
        verbose_name=_('Logo'),
        help_text=_('Path to the logo'),
        null=True,
    )
    description = models.TextField(verbose_name=_('Description'))
    users = models.ManyToManyField(
        settings.AUTH_USER_MODEL,
        default=None,
        verbose_name=_('Users')
    )

    def get_absolute_url(self):
        return reverse('application_system:list_app')

    def __str__(self):
        string_length = 20
        if len(self.name) > string_length:
            name = self.name[:string_length-1] + '...'
        else:
            name = self.name
        return u'<App: name="{name}">'.format(name=name)

    def __eq__(self, instance):
        return instance.slug == self.slug

    def save(self, *args, **kwargs):
        app = App.objects.filter(package=self.package).first()
        if app:
            logger.info('App already installed, updating app')
            self.id = app.id
        else:
            logger.info('Installing app')
        super(App, self).save(*args, **kwargs)
        if app:
            logger.info('App updated')
        else:
            logger.info('App installed')

berou/application_system/views.py
# -*- coding: utf-8 -*-

from django.core.urlresolvers import reverse_lazy
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView

from berou import mixins
from application_system import models
#from berou import settings as project_settings


class ListAppView(ListView):
    model = models.App
    template_name = 'application_system/list_app.html'


class InstallAppView(mixins.LoginRequiredMixin, CreateView):
    model = models.App
    fields = ['name']
    success_url = reverse_lazy('application_system:list_app')


class UninstallAppView(mixins.LoginRequiredMixin, DeleteView):
    model = models.App
    template_name = 'application_system/confirm_uninstall_app.html'
    success_url = reverse_lazy('application_system:list_app')


class ListAvailableAppView(mixins.LoginRequiredMixin, ListAppView):
    template_name = 'application_system/list_available_app.html'
    model = models.App

    def get_context_data(self, **kwargs):
        context = super(ListAvailableAppView, self).get_context_data(**kwargs)
        context['installed_apps'] = [app for app in models.App.objects.all()
                                     if self.request.user in app.users.all()]
        return context


class ActivateAppView(mixins.LoginRequiredMixin, UpdateView):
    model = models.App
    fields = []
    slug_field = 'package'
    slug_url_kwarg = 'package'
    success_url = reverse_lazy('application_system:manage_my_apps')

    def get_object(self, queryset=None):
        obj = super(ActivateAppView, self).get_object(queryset)
        return obj

    def form_valid(self, form):
        form.instance.users.add(self.request.user)
        return super(ActivateAppView, self).form_valid(form)


class DisableAppView(mixins.LoginRequiredMixin, UpdateView):
    model = models.App
    fields = []
    slug_field = 'package'
    slug_url_kwarg = 'package'
    success_url = reverse_lazy('application_system:manage_my_apps')

    def form_valid(self, form):
        form.instance.users.remove(self.request.user)
        return super(DisableAppView, self).form_valid(form)

berou/application_system/templates/application_system/confirm_uninstall_app.html
{% extends 'berou/base.html' %}
{% load i18n %}
{% block content %}
<div class="row">
    <form action="" method="post">
        {% csrf_token %}
        <h3>{% trans "Are you sure you want to uninstall" %} <a href="{{ object.name }}">{{ object.name }}</a>?</h3>
        <button class="btn btn-primary" type="submit">{% trans "Confirm" %}</button>
    </form>
</div>
{% endblock content %}

berou/application_system/templates/application_system/list_app.html
{% extends 'berou/base.html' %}
{% load i18n %}
{% block content %}
<div class="row">
    <div class="panel-links panel-links-default">
        <div class="panel-links-heading">
            <h4>{% trans "List of apps" %}</h4>
        </div>
        <div class="panel-links-body">
            <ul class="list-group">
                {% for app in object_list %}
                <li class="list-group-item">{{ app.slug }}</a>
            {% if user.is_authenticated %}
            <a href="{% url 'application_system:uninstall_app' slug=app.slug %}" class="btn btn-danger pull-right">
                {% trans "Uninstall" %}
            </a>
            {% endif %}
            </li>
            {% endfor %}
        </ul>
    </div>
</div>
{% endblock content %}

berou/application_system/templates/application_system/list_available_app.html
{% extends 'berou/base.html' %}
{% load i18n staticfiles %}
{% block content %}
<div class="row">
    <div class="panel-links panel-links-default">
        <div class="panel-links-heading">
            <h4>{% trans "List of apps" %}</h4>
        </div>
        <div class="panel-links-body">
            <ul class="list-group container-fluid">
                {% for app in object_list %}
                <li class="list-group-item row">
                    <div class="col-md-1">
                        {% if app.logo %}
                        <img class="logo" src="{{ app.logo }}" alt="{{ app.name }} logo" />
                        {% else %}
                        <img class="logo" src="{% static 'application_system/img/no_logo.svg' %}" alt="{{ app.name }} logo" />
                        {% endif %}
                    </div>
                    <div class="col-md-9">
                        <h4>{{ app.name }}</h4>
                        <h5>{{ app.description }}</h5>
                    </div>
                    {% if user in app.users.all %}
                    <div class="col-md-2">
                        <form class="pull-right" method="POST" action="{% url 'application_system:disable_app' package=app.package %}">
                            {% csrf_token %}
                            <button class="pull-right btn btn-danger">{% trans "Disable" %}</button>
                        </form>
                    </div>
                    {% else %}
                    <div class="col-md-2">
                        <form class="pull-right" method="POST" action="{% url 'application_system:activate_app' package=app.package %}">
                            {% csrf_token %}
                            <input name="package" value="{{ app.package }}" type="hidden" />
                            <button class="btn btn-info">{% trans "Enable" %}</button>
                        </form>
                    </div>
                    {% endif %}
                </li>
                {% endfor %}
            </ul>
        </div>
    </div>
</div>
{% endblock content %}